### Method

# Camel Session authenticate

since: 3.4

#### Declaration [src]

    void
    camel_session_authenticate (
      CamelSession* session,
      CamelService* service,
      const gchar* mechanism,
      gint io_priority,
      GCancellable* cancellable,
      GAsyncReadyCallback callback,
      gpointer user_data
    )

#### Description [src]

Asynchronously authenticates `service`, which may involve repeated calls to `camel_service_authenticate()` or camel_service_authenticate_sync(). A `CamelSession` subclass is largely responsible for implementing this, and should handle things like user prompts and secure password storage. These issues are out-of-scope for Camel.

When the operation is finished, `callback` will be called. You can then call `camel_session_authenticate_finish()` to get the result of the operation.

Available since: 3.4

This method completes asynchronously. Use `camel_session_authenticate_finish()` inside the `GAsyncReadyCallback` to obtain the result of the operation.

#### Parameters

`service`

  Type: `CamelService`

  A `CamelService`.

  The data is owned by the caller of the method.

`mechanism`

  Type: `const gchar*`

  A SASL mechanism name, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`io_priority`

  Type: `gint`

  The I/O priority for the request.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`callback`

  Type: `GAsyncReadyCallback`

  A `GAsyncReadyCallback` to call when the request is satisfied.

  The argument can be `NULL`.

`user_data`

  Type: `gpointer`

  Data to pass to the callback function.

  The argument can be `NULL`.
  The data is owned by the caller of the method.